var Save_CW,Chop_CW:word;

{ Quick-- - ⮫쪮  稨 ᮯ 387   }

function QuickSin(x:extended):extended;
inline($8b/$DC/$36/$DB/$2F/$d9/$fe/$83/$c4/$0a);
  { mov bx,sp
    fld ss:tbyte ptr [bx]
    fsin
    add sp,0ah }

function QuickCos(x:extended):extended;
inline($8b/$DC/$36/$DB/$2F/$d9/$ff/$83/$c4/$0a);
  { mov bx,sp
    fld ss:tbyte ptr [bx]
    fcos
    add sp,0ah }

function QuickTan(x:extended):extended;
inline($8b/$DC/$36/$DB/$2F/$d9/$f2/$dd/$d8/$83/$c4/$0a);
  { mov bx,sp
    fld ss:tbyte ptr [bx]
    fptan
    fstp st(0)
    add sp,0ah }

function QuickAtan(x:extended):extended;
inline($8b/$DC/$36/$DB/$2F/$d9/$e8/$d9/$f3/$83/$c4/$0a);
  { mov bx,sp
    fld ss:tbyte ptr [bx]
    fld1
    fpatan
    add sp,0ah }

function QuickLn(x:extended):extended;
inline($8b/$DC/$d9/$ed/$36/$DB/$2F/$d9/$f1/$83/$c4/$0a);
  { mov bx,sp
    fldln2
    fld ss:tbyte ptr [bx]
    fyl2x
    add sp,0ah }

{ ⮪  x/y }
function QuickReminder(x,y:extended):extended;
inline($8b/$DC/$36/$DB/$2F/$36/$db/$6f/$0a/$d9/$f8/$dd/$d9/$83/$c4/$14);
  { mov bx,sp
    fld ss:tbyte ptr [bx]
    fld ss:tbyte ptr [bx+0ah]
    fprem
    fstp st(1)
    add sp,14h }

{ x^y }
function QuickExp(x,y:extended):extended;
inline($8b/$DC/$36/$DB/$2F/$36/$db/$6f/$0a/$d9/$f1/$d9/$c0/
         $d9/$3e/Save_CW/$9b/$a1/Save_CW/$25/$ff/$f3/$0d/$00/$0c/
         $a3/InitExpRec/$d9/$2e/InitExpRec/$d9/$fc/$d8/$e9/$d9/$f0/
         $d9/$e8/$de/$c1/$d9/$fd/$dd/$d9/$d9/$2e/Save_CW/$83/$c4/$14);
  { mov bx,sp
    fld ss:tbyte ptr [bx]
    fyl2x
    fld st(0)
    fstcw word ptr [Save_CW]
    wait
    mov ax,[Save_CW]
    and ax,0f3ffh
    or ax,0c00h
    mov [Chop_CW],ax
    fldcw word ptr [Chop_CW]
    frndint
    fsubr st,st(1)
    f2xm1
    fld1
    faddp st(1),ST
    fscale
    fstp st(1)
    fldcw word ptr [Save_CW]
    add sp,14h }

Function IntPow(X:extended; Y:word):extended;assembler; { Returns x^y }
asm
 fld1             { Load 1 }
 mov cx,Y
 fld X            { Load x }
 jcxz @exit       { If y already zero, return }
@TestY:
 test cx,1        { Is the LSB of y set? }
 jz @NextIt
 fmul st(1),st    { res=res*x }
@NextIt:
 fmul st,st(0)    { square x }
 shr cx,1         { y=y/2 }
 jnz @TestY       { Continue if nonzero }
@exit:
 fstp st          { Pop stack.  Return value is now in ST(0) }
end;

Function SumArray(Var Arr; N:integer):extended;assembler;
{ Returns sum of the n elements in arr }
asm
 les bx,Arr
 mov cx,N        { Get number of elements }
 fldz            { Load zero }
 jcxz @exit      { Leave if count is 0 }
@DoSum:
 fadd qword ptr es:[bx] { Add value in array to ST(0) }
 add bx,8        { Point to next value in array }
 loop @DoSum     { Loop until done }
@exit:           { Return value in ST(0) }
end;

Function SolveQuadratic(a,b,c:double; Var x1,x2:double):integer;assembler;
{ solve_quadratic takes the coefficients of a quadratic polynomial
 and finds the roots of that polynomial.  If there are two real
 roots, it writes them back to x1 and x2 and returns 1.  If the
 discriminant b^2-4*a*c is less than 0, the roots are not real
 and solve_quadratic returns 0.
 The quadratic formula is as follows: (-b +/- sqrt(b*b-4*a*c)) / 2*a}
asm
             { Comments show stack contents }
             { separated by | signs         }
             { Stack top is at left         }
 fld A       { a     Here, ST(0) contains a.}
 fld B       { b | a     Now ST(1) has a. Etc.}

 { Negate b -- squaring it is sign-independent, and we need b
  negated in all the other instances in the formula.}
 fchs
 fld C         { c | b | a       }
 fld st(1)     { b | c | b | a   }
 fmul st,st(0) { b*b | c | b | a }

 { Just plain fxch has an implicit operand of ST(1) }
 fxch            { c | b*b | b | a     }
 fadd st,st(0)   { 2*c | b*b | b | a   }
 fadd st,st(0)   { 4*c | b*b | b | a   }
 fmul st,st(3)   { 4*a*c | b*b | b | a }
 fsubp st(1), st { b*b-4*a*c | b | a   }
 ftst            { Compare against 0   }

 { We've computed b*b-4*a*c.  If negative, we return 0.
   To do the comparison, we have to store the 80x87 status
   word and use sahf to store it into the flags.  Once it's
   in the flags, we can jump on above or equal (jae) to jump if the
   number tested is greater than 0 after the FTST instruction above }
 sub sp,2        { Quick, allocate a local }
 mov bx,sp       { Point BX at it }
 fstsw ss:[bx]   { Store the 80x87's status word there }
 mov ax,ss:[bx]  { AX <- status word }
 add sp,2        { Deallocate the local }
 sahf            { Get SW into flags }
 jae @ComputeRes { Jump if positive }
 fstp st         { This instruction clears the stack }
 fstp st         { we've got three values on the stack }
 fstp st         { to clear }
 xor ax,ax       { Return 0 - no roots found }
 jmp @exit
@ComputeRes:
 fsqrt           { Find square root of discriminant }
 fxch st(2)      { a | b | sqrt(b*b-4*a*c) }
 fadd st,st(0)   { 2*a | b | sqrt(b*b-4*a*c) }
 fld st(1)       { b | 2*a | b | sqrt(b*b-4*a*c) }
 fadd st,st(3)   { b+sqrt(b*b-4*a*c) | 2*a | b | sq.. }
 fdiv st,st(1)   { x1 | 2*a | b | sqrt(b*b-4*a*c) }
 les bx,X1
 fstp qword ptr es:[bx] { 2*a | b | sqrt(b*b-4*a*c) }
 fxch            { b | 2*a | sqrt(b*b-4*a*c) }
 fsubrp st(2),st { 2*a | -b - sqrt(b*b-4*a*c) }
 fdiv            { x2 }
 les bx,X2       { Store x2 }
 fstp qword ptr es:[bx]
 mov ax,1        { Return 1 }
@exit:
end;

var
 InitExpRec:record
  case integer of
   0: (Chop_CW:extended);
   1: (S_0:word; S_E:longint; D_E:double; E_E:extended; X,Y:longint)
 end;

procedure ExpInit;assembler;
asm
   jmp @1
@2: db 0cdh,0cch,0cch,0cch,0cch,0cch,0cch,0c4h,02h,40h
@3: db 0cdh,0cch,0cch,0cch,0cch,0cch,0cch,08ch,0ffh,03fh
@1:
   fld cs:tbyte ptr @2
   fstp dword ptr InitExpRec.X
   fwait
   fld cs:tbyte ptr @3
   fmul dword ptr InitExpRec.X
   fstp dword ptr InitExpRec.Y
   fwait
   fldl2e
   fld1
   fsubp st(1),st
   f2xm1
   fld1
   faddp st(1),st
   fld1
   fld1
   faddp st(1),st
   fst dword ptr InitExpRec.S_E
   wait
   fst qword ptr InitExpRec.D_E
   wait
   fstp tbyte ptr InitExpRec.E_E
   wait
end;

Var v:extended; x1,x2:double;
    A:array[1..4] of double;
begin
 v:=4;
 writeln;
 writeln(IntPow(v,3));
 a[1]:=1; a[2]:=2; a[3]:=3; a[4]:=10;
 writeln(SumArray(A,4));
 SolveQuadratic(1,-8,15,x1,x2);
 writeln('x1=',x1,' x2=',x2)
end.

