{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit Def2x2;

Interface

Const

 { Term types }
 { !!!   祭 ⠭   冷 }

 opNull       = 0 ;
 opOther      = 1 ;
 opBlank      = 2 ;
 opLBra       = 3 ; { ( }
 opRBra       = 4 ; { ) }
 opLBrack     = 5 ; { [ }
 opOutSign    = 6 ; { @ }
 opBadLog     = 7 ;
 opV          = 8 ; { ! }

 opConst      = 10 ;
 opPar        = opConst+1 ;
 opUknown     = opConst+2 ;
 opDoubleVar  = opConst+3 ;
 opVar        = opConst+4 ;
 opNewVar     = opConst+5 ;
 opArrayVar   = opConst+6 ;
 opPolinom    = opConst+7 ;
 opStrArrVar  = opConst+8 ;
 opMatrixVar  = opConst+9 ;
 opAnyArrVar  = opConst+10 ;

 opIf         = 23 ;
 opWhile      = opIf+1 ;
 opRepeat     = opIf+2 ;
 opElse       = opIf+4 ;
 opSemiColon  = opIf+5 ;
 opEndData    = opIf+6 ;
 opEndWhile   = opIf+7 ;
 opEndIf      = opIf+8 ;
 opEndElse    = opIf+9 ;
 opEndFunc    = opIf+10 ;
 opUntil      = opIf+11 ;
 { १ࢨ஢    ᥬ-࠭⥫ }
 opEnd        = opIf+15 ;

 opColon      = opIf+16 ; { : }
 opRBrack     = opIf+17 ; { ] }
 opAssign     = opIf+18 ; { = }
 opDo         = opIf+19 ; { do }
 opThen       = opIf+20 ; { then }
 opRel        = opIf+21 ;
 opLogic      = opIf+22 ;
 opComma      = opIf+23 ; { , }

 opFunc0      = 47 ;
 opFunc1      = 48 ;
 opFunc2      = 49 ;

 opArrayDef   = 50 ;
 opPolinomDef = opArrayDef+1 ;
 opMatrixDef  = opArrayDef+2 ;
 opFuncDef    = opArrayDef+3 ;
 opProcDef    = opArrayDef+4 ;
 opStringDef  = 55 ; { string }

 opExtern     = 56 ;
 opBreak      = 57 ;
 opContinue   = opBreak+1 ;
 opExit       = opBreak+2 ;
 opBegin      = 60 ;
 opYetDone    = 61 ;
 opFunc       = 62 ;

 opStringConst= 63 ;
 opStringVar    = opStringConst+1 ;
 opNewStringVar = opStringConst+2 ;
 opStringDouble = opStringConst+3 ;
 opStringPar    = opStringConst+4 ;

 opSimm       = 70 ; { Simmetr }
 opDiag       = 71 ; { Diag    }
 opOut        = 72 ; { Out     }
 opParDef     = 73 ; { Par     }
 opText       = 74 ; { ' }
 opUserConst  = 75 ;
 opPrint      = 76 ;
 opOf         = 77 ;
 opStrConcat  = 78 ;
 opMultiVar   = 79 ;
 opFloatDef   = 80 ;
 opCompFunc   = 81 ;
 { 82..100 - ᢮ }
 opUserType1  = 101; { 101..150 - ⨯ 짮⥫ }
 opUserType2  = 150;
 opUserVar1   = 151; { 151..200 - ६ 짮⥫ }
 opUserVar2   = 200;
 UserTypeVarDelta=opUserVar1-opUserType1;
 opParProc    = $FE { $7E} ;
 opParFunc    = $FF { $7F} ;
 {  ⠭ 8-   >FF }
 opUserFunc      = $0100 { $80}  ;
 opStringFunc    = $1100 { $180} ;
 opDirectFunc    = $2100 ;
 opDirectStrFunc = $3100 ;
 opUserProc      = $4100 { $280} ;
 opDirectProc    = $5100 ;

Const
 utfByPar =  1;

 wmpUknown           = opUserType1-9;
 wmpFloatMultiPar    = opUserType1-8;
 wmpStrMultiPar      = opUserType1-7;
 wmpArrayMultiPar    = opUserType1-6;
 wmpUserTypeMultiPar = opUserType1-5;
 wmpRes0             = opUserType1-4;
 wmpRes1             = opUserType1-3;
 wmpRes2             = opUserType1-2;
 wmpRes3             = opUserType1-1;
 wmpUserType1        = opUserType1;
 wmpUserType2        = opUserType2;

 dctFloat     = opUserType1-5;
 dctString    = opUserType1-4;
 dctAnyArray  = opUserType1-3;
 dctArray     = opUserType1-2;
 dctStrArray  = opUserType1-1;
 dctUserType1 = opUserType1;
 dctUserType2 = opUserType2;

Type
 TFuncOptions=set of (foAsProperty,foSimplified);
 TMultiExprType=wmpUknown..wmpUserType2;
 OpsType=opNull..opDirectProc;
 TUserVarType=opUserType1..opUserType2;
 FArrayType=(atFloat,atString);
 TReturnType=(rtFloat,rtString);
 TPasReturnType=(prtByte,prtChar,prtBoolean,prtInt,prtWord,prtLong,prtPointer,
                 prtDouble,prtExtended,prtString);
 TPasParType=(pptByte,pptChar,pptBoolean,pptInt,pptWord,pptLong,pptPointer,pptDouble,
              pptExtended,pptString,pptArray);
 T2x2Type=dctFloat..dctUserType2;
 TRunBreak=(rbBreak,rbContinue,rbExit);
 TSubrType=(wcFunc,wcProc);
 TStackOperation=(pctE2I,pctE2W,pctPE2I,pctI2E,pctE2L,pctPE2L,pctL2E,pctE2D,
                  pctPE2D,pctD2E,pctE2E,pctP2P,pctPP2P);

Const
 rtDontCare=rtFloat;
 prtDontCare=prtByte;

Const
 { Block types }

 wbGlobal     = 0   ;
 wbIf         = 1   ;
 wbWhile      = 2   ;
 wbRepeat     = 3   ;
 wbArrayDef   = 7   ;
 wbPolinomDef = 8   ;
 wbMatrixDef  = 9   ;
 wbElse       = 12  ;
 wbFuncDef    = $80 ;
 wbProcDef    = $80 ;

 { Boolean types }

 rtG  = 0; { >  }
 rtGE = 1; { >= }
 rtL  = 2; { <  }
 rtLE = 3; { <= }
 rtE  = 4; { =  }
 rtNE = 5; { <> }
 rtIsZero = 6; { =0 }
 rtIsOne  = 7; { =1 }
 LastrtFloat=rtIsOne;

 rtsG  =  LastrtFloat+1; { >  }
 rtsGE =  LastrtFloat+2; { >= }
 rtsL  =  LastrtFloat+3; { <  }
 rtsLE =  LastrtFloat+4; { <= }
 rtsE  =  LastrtFloat+5; { =  }
 rtsNE =  LastrtFloat+6; { <> }

 { Logic types }

 ltAnd = 0 ; { AND }
 ltOr  = 1 ; { OR  }
 ltNot = 2 ; { NOT }
 ltXor = 3 ; { XOR }

 { Expression types }

 etNull          = 0            ;
 etFormula       = 1            ;  { ᫮ - ᢠ }
 etIf            = 2            ;  { 横 While      }
 etWhile         = 3            ;  { 横 If         }
 etRepeat        = 4            ;  { 横 Repeat     }
 etArrayCell     = 5            ;  { - ᢠ - ᫮ ᨢ }
 etStrFormula    = 6            ;  { ப - ᢠ }
 etArrayDef      = wbArrayDef   ;  { 7, ᠭ ᨢ  }
 etPolinomDef    = wbPolinomDef ;  { 8, ᠭ  }
 etMatrixDef     = wbMatrixDef  ;  { 9 }
 etLogic         = 10           ;  { ᪮ ࠦ }
 etBool          = 11           ;  { ࠦ ⭮襭 (ࠢ) }
 etElse          = wbElse       ;  { 12,  else }
 etPrint         = 15           ;  {  Print }
 etStrArrayCell  = 16           ;  { - ᢠ - ப ᨢ }
 etProcDef       = 20           ;  { ᠭ 楤 }
 etProc          = 21           ;
 etAssignFunc    = 25           ;  { - ᢠ 祭 - }
 etAssignStrFunc = 26           ;
 etFuncProp      = 27           ;  { - ᢠ 祭 --property }
 etStrFuncProp   = 28           ;
 etUserTypeFormula = 29         ;
 etCompFunc      = 30           ;  { IsTrue, IsFalse }
 etBreak         = opBreak      ;  { 56 }
 etContinue      = opContinue   ;  { 57 }
 etExit          = opExit       ;  { 58 }
 etText          = opText       ;  { 74 }
 etFuncDef       = wbFuncDef    ;  { $80, ᠭ 㭪樨 }

 AropetDel=opArrayDef-etArrayDef; { ࠧ opArrayDef-etArrayDef }
 OpArDel=opArrayDef-opArrayVar;

Type
 ExprType=etNull..etFuncDef;

Const

 { function types }

 f1Neg    = 0  ;
 f1Sin    = 1  ;
 f1Cos    = 2  ;
 f1Tg     = 3  ;
 f1Arcsin = 4  ;
 f1Arccos = 5  ;
 f1Arctg  = 6  ;
 f1Abs    = 7  ;
 f1Sqr    = 8  ;
 f1Sqrt   = 9  ;
 f1Rad    = 10 ;
 f1Grad   = 11 ;
 f1Ln     = 12 ;
 f1Lg     = 13 ;
 f1Exp    = 14 ;
 f1Sign   = 15 ;
 f1Frac   = 16 ;
 f1Round  = 17 ;
 f1Trunc  = 18 ;
 f1Error  = 20 ;

 { math operation types }

 moPlus  = f1Error+1   ; { + }
 moMinus = f1Error+2   ; { - }
 moMult  = f1Error+3   ; { * }
 moDiv   = f1Error+4   ; { / }
 moPower = f1Error+5   ; { ^ }
 moLDiv  = f1Error+6   ; { div }
 moLMod  = f1Error+7   ; { mod }

 FuncIndex2x2=100; { max  -, १ࢨ஢  2x2;
                     - -   訥 100 }

 { errors }

 teOK               =  0 ;
 teSyntax           =  1 ;
 teIncorrectChar    =  2 ;
 teMathExpected     =  3 ;
 teInvNameLen       =  4 ;
 teDoubleName       =  5 ;
 teRBraExpected     =  6 ;
 teLBraExpected     =  7 ;
 teEIE              =  8 ;
 teUnexpectedEnd    =  9 ;
 teLBrackExpected   =  10;
 teRBrackExpected   =  11;
 teEndExpected      =  12;
 teUknownVar        =  13;
 teBraUnnecessary   =  14;
 teBraFromLogic     =  15;
 teRelExpected      =  16;
 teThenExpected     =  17;
 teDoExpected       =  18;
 teEndElseExpected  =  19;
 teEndIfExpected    =  20;
 teEndWhileExpected =  21;
 teAssignExpected   =  24;
 teNoData           =  25;
 {teNoDataInCycle    =  26;}
 teResword          =  27;
 teFirstNumber      =  28;
 teEIS              =  29;
 teLocArrDef        =  30;
 teLocPolDef        =  teLocArrDef+1;
 teLocMatrixDef     =  teLocPolDef+1;
 teLocFuncDef       =  33;
 teOriginNameExpected = 34;
 teArrayNameExpected  = 35;
 tePolNameExpected    = teArrayNameExpected+1;
 teMatrixNameExpected = tePolNameExpected+1;
 teAnyArrNameExpected = tePolNameExpected+2;
 teNotExternAr      =  39;
 teNotExternPol     =  teNotExternAr+1;
 teNotExternMatrix  =  teNotExternPol+1;
 teParInCellVal     =  42;
 teEndFuncExpected  =  43;
 teFuncNameExpected =  44;
 teTooManyPars      =  45;
 teVarNameExpected  =  46;
 teFuncSignsExpected=  47;
 teCommaExpected    =  48;
 teFuncMismatch     =  49;
 tePolDefLoc        =  50;
 teEndArrDefExpected=  51;
 teInvArraySize     =  52;
 teFloatExpected    =  53;
 teTextEndExpected  =  54;
 teInvFormat        =  55;
 teParDiff          =  56;
 teStructNotOut     =  57;
 teConstExpected    =  58;
 teInvOutLoc        =  59;
 teInvParDefLoc     =  60;
 teStringNotOut     =  61;
 teStringDiff       =  62;
 teInvStringDefLoc  =  63;
 teStringDefExpected=  64;
 teStrExprExpected  =  65;
 teStringVarExpected=  66;
 teTooManyCells     =  67;
 teDimNotEqual      =  68;
 teStrArNoGeneral   =  69;
 teInvStrLenDef     =  70;
 teStrConstExpected =  71;
 teStrLenMismatch   =  72;
 teBigFloat         =  73;
 teNoFreeFuncId     =  74;
 teOpTypesMismatch  =  75;
 teProcNameExpected =  76;
 teExternInGlobal   =  77;
 teLocAsGlobal      =  78;
 teNotExistInGlobal =  79;
 teParInSizeVal     =  80;
 teUserVarExpected  =  81;
 teBadPrivOp        =  82;
 teUserTypeNotOut   =  83;
 teUserTypeDiff     =  84;
 teInvUserTypeDefLoc=  85;
 teCommaUnnecessary =  86;

Const
 MaxTermLen=15;   { Max   ଠ }
 MaxResWords=57;  { ᫮ १ࢨ஢  }

Type
 TermString=string[MaxTermLen];

 HLWord=record
  Hi,Lo:byte
 end;

 ResWordType=record
  Name:TermString;
  TermType:OpsType;
  TermWhat:byte;
  Hash:byte;
 end;
 AResWords=array[1..MaxResWords] of ResWordType;
 PResWords=^AResWords;

Const

 { reserved names }

 ResWords:AResWords=(
  (Name:'SIN'     ; TermType:opFunc1     ; TermWhat:f1Sin    ; Hash:28),
  (Name:'COS'     ; TermType:opFunc1     ; TermWhat:f1Cos    ; Hash:15),
  (Name:'TG'      ; TermType:opFunc1     ; TermWhat:f1Tg     ; Hash:22),
  (Name:'ARCSIN'  ; TermType:opFunc1     ; TermWhat:f1Arcsin ; Hash: 0),
  (Name:'ARCCOS'  ; TermType:opFunc1     ; TermWhat:f1Arccos ; Hash:19),
  (Name:'ARCTG'   ; TermType:opFunc1     ; TermWhat:f1Arctg  ; Hash: 0),
  (Name:'ABS'     ; TermType:opFunc1     ; TermWhat:f1Abs    ; Hash: 2),
  (Name:'SQR'     ; TermType:opFunc1     ; TermWhat:f1Sqr    ; Hash:10),
  (Name:'SQRT'    ; TermType:opFunc1     ; TermWhat:f1Sqrt   ; Hash: 6),
  (Name:'RAD'     ; TermType:opFunc1     ; TermWhat:f1Rad    ; Hash:26),
  (Name:'GRAD'    ; TermType:opFunc1     ; TermWhat:f1Grad   ; Hash:20),
  (Name:'LN'      ; TermType:opFunc1     ; TermWhat:f1Ln     ; Hash:28),
  (Name:'LG'      ; TermType:opFunc1     ; TermWhat:f1Lg     ; Hash: 6),
  (Name:'EXP'     ; TermType:opFunc1     ; TermWhat:f1Exp    ; Hash: 4),
  (Name:'SIGN'    ; TermType:opFunc1     ; TermWhat:f1Sign   ; Hash:24),
  (Name:'FRAC'    ; TermType:opFunc1     ; TermWhat:f1Frac   ; Hash:23),
  (Name:'ROUND'   ; TermType:opFunc1     ; TermWhat:f1Round  ; Hash:12),
  (Name:'TRUNC'   ; TermType:opFunc1     ; TermWhat:f1Trunc  ; Hash:15),
  (Name:'ERROR'   ; TermType:opFunc1     ; TermWhat:f1Error  ; Hash: 0),
  (Name:'DIV'     ; TermType:opFunc2     ; TermWhat:moLDiv   ; Hash: 3),
  (Name:'MOD'     ; TermType:opFunc2     ; TermWhat:moLMod   ; Hash:29),

  (Name:'EXTERN'  ; TermType:opExtern    ; TermWhat:0        ; Hash:21),
  (Name:'ARRAY'   ; TermType:opArrayDef  ; TermWhat:0        ; Hash:13),
  (Name:'POLINOM' ; TermType:opPolinomDef; TermWhat:0        ; Hash:29),
  (Name:'MATRIX'  ; TermType:opMatrixDef ; TermWhat:0        ; Hash:10),

  (Name:'OR'      ; TermType:opLogic     ; TermWhat:ltOR     ; Hash:18),
  (Name:'AND'     ; TermType:opLogic     ; TermWhat:ltAND    ; Hash:11),
  (Name:'XOR'     ; TermType:opLogic     ; TermWhat:ltXOR    ; Hash:25),
  (Name:'NOT'     ; TermType:opLogic     ; TermWhat:ltNOT    ; Hash:02),

  (Name:'WHILE'   ; TermType:opWhile     ; TermWhat:0        ; Hash: 1),
  (Name:'ENDWHILE'; TermType:opEndWhile  ; TermWhat:0        ; Hash:19),
  (Name:'IF'      ; TermType:opIf        ; TermWhat:0        ; Hash:26),
  (Name:'ENDIF'   ; TermType:opEndIf     ; TermWhat:0        ; Hash: 5),
  (Name:'DO'      ; TermType:opDo        ; TermWhat:0        ; Hash:13),
  (Name:'THEN'    ; TermType:opThen      ; TermWhat:0        ; Hash:30),
  (Name:'ELSE'    ; TermType:opElse      ; TermWhat:0        ; Hash:27),
  (Name:'ENDELSE' ; TermType:opEndElse   ; TermWhat:0        ; Hash:28),
  (Name:'FUNC'    ; TermType:opFuncDef   ; TermWhat:0        ; Hash:25),
  (Name:'ENDFUNC' ; TermType:opEndFunc   ; TermWhat:0        ; Hash:30),
  (Name:'END'     ; TermType:opEnd       ; TermWhat:0        ; Hash:26),
  (Name:'REPEAT'  ; TermType:opRepeat    ; TermWhat:0        ; Hash: 0),
  (Name:'UNTIL'   ; TermType:opUntil     ; TermWhat:0        ; Hash: 5),
  (Name:'BREAK'   ; TermType:opBreak     ; TermWhat:0        ; Hash:10),
  (Name:'CONTINUE'; TermType:opContinue  ; TermWhat:0        ; Hash:25),
  (Name:'BEGIN'   ; TermType:opBegin     ; TermWhat:0        ; Hash:08),
  (Name:'DIAG'    ; TermType:opDiag      ; TermWhat:0        ; Hash:00),
  (Name:'SIMMETR' ; TermType:opSimm      ; TermWhat:0        ; Hash:18),
  (Name:'OUT'     ; TermType:opOut       ; TermWhat:0        ; Hash:16),
  (Name:'PAR'     ; TermType:opParDef    ; TermWhat:0        ; Hash:28),
  (Name:'STRING'  ; TermType:opStringDef ; TermWhat:0        ; Hash:20),
  (Name:'PRINT'   ; TermType:opPrint     ; TermWhat:0        ; Hash:17),
  (Name:'EXIT'    ; TermType:opExit      ; TermWhat:0        ; Hash:11),
  (Name:'OF'      ; TermType:opOf        ; TermWhat:0        ; Hash:30),
  (Name:'PROC'    ; TermType:opProcDef   ; TermWhat:0        ; Hash:14),
  (Name:'FLOAT'   ; TermType:opFloatDef  ; TermWhat:0        ; Hash:11),
  (Name:'ISTRUE'  ; TermType:opCompFunc  ; TermWhat:rtIsOne  ; Hash:19),
  (Name:'ISFALSE' ; TermType:opCompFunc  ; TermWhat:rtIsZero ; Hash: 0)
  );

Const
 MaxSpecialChar=21;
 SpecialString:string[MaxSpecialChar]='+-/*();,= %@^[]'':!><';
 PSpecialString:pointer=@SpecialString;

 Diff1Char='`';
 Diff2Char='"';
 AssignChar='=';
 GreatChar='>';
 TextChar='''';

 scRBrack= 16;
 scG     = 20;
 scL     = 21;
 scText  = 17;
 scColon = 18;
 scV     = 19;
 scBlank = 10;

Type
 RSpecialChars=record
  Stype:OpsType;
  What:byte
 end;

Const
 SpecialChars:array[1..MaxSpecialChar] of RSpecialChars=(
  (Stype:opFunc2      ; What:moPlus  ),
  (Stype:opFunc2      ; What:moMinus ),
  (Stype:opFunc2      ; What:moDiv   ),
  (Stype:opFunc2      ; What:moMult  ),
  (Stype:opLBra       ; What:0       ),
  (Stype:opRBra       ; What:0       ),
  (Stype:opSemiColon  ; What:0       ),
  (Stype:opComma      ; What:0       ),
  (Stype:opAssign     ; What:rtE     ),
  (Stype:opBlank      ; What:0       ),
  (Stype:opFunc2      ; What:moLMod  ),
  (Stype:opOutSign    ; What:0       ),
  (Stype:opFunc1      ; What:f1Sqrt  ),
  (Stype:opFunc2      ; What:moPower ),
  (Stype:opLBrack     ; What:0       ),
  (Stype:opRBrack     ; What:0       ),
  (Stype:opText       ; What:0       ),
  (Stype:opColon      ; What:0       ),
  (Stype:opV          ; What:0       ),
  (Stype:opRel        ; What:rtG     ),
  (Stype:opRel        ; What:rtL     ) );

 BlankPos=10;

 MaxFuncPars=10;      { max ᫮ ࠬ஢ - }
 FuncMask=$F100{ $F80}{opUserFunc};
 AllMask=$FFFF;
 TextTermSize=255;    { max  ப ६ }

 stFormat1=10; { ଠ ᫠  㬮砭 }
 stFormat2=6;

Type

 TextTerm=string[TextTermSize-1];
 PText=^TextTerm;

 ListModeType=(lmParList,lmOutList,lmStringList,lmUserVarList);
 OutPrintModeType=(pmPrint,pmOut);

Implementation

End.