Procedure fMailAddres(Var P:TCalcCell);
Type PPointer=^pointer;
Begin
 PPointer(P.T1)^:=PPointer(P.T2)^
End;

Procedure fPopParAddres(Var P:TCalcCell);
Begin
 PFloat(P.T1)^:=PFloat(P.T2)^
End;

Procedure fPopTen(Var P:TCalcCell);
Begin
 with P do FastMoveWord(T2^,T1^,5);
End;

Procedure fPopString(Var P:TCalcCell);
Begin
 PText(Ppointer(P.T1)^)^:=PText(Ppointer(P.T2)^)^
End;

Procedure fCalcUserFunc(Var P:TCalcCell);
Begin
 With P do begin
  PCalcer(T1)^.Evaluate;
  Result:=PFloat(T2)^
 end
End;

Procedure fCalcUserProc(Var P:TCalcCell);
Begin
 With P do PCalcer(T1)^.Evaluate;
End;

Procedure fCalcStringFunc(Var P:TCalcCell);
Begin
 With P do begin
  PCalcer(T1)^.Evaluate;
  PText(ResultP)^:=PText(Ppointer(T2)^)^;
 end
End;

Procedure fPopMParAddres(Var P:TCalcCell);
var MF:PMultiFact;
Begin
 New(MF);
 With P,MF^ do begin
  PCollection(T1)^.Insert(MF);
  ByValue:=longint(Aux) and $8000=0;
  case TMultiExprType(longint(Aux) and not $8000) of
   wmpFloatMultiPar: Value:=T2; { PFloat }
   else Value:=Ppointer(T2)^;   { PText,PMatrix }
  end
 end
End;

Procedure fAssignPropValue(Var P:TCalcCell);
begin
 With P do PUserFunc(T1)^.AssignValue(T2)
end;

Procedure fCalcClearMultiList(Var P:TCalcCell);
begin
 With P do PUserProc(T1)^.ClearMultiList(longint(T2));
end;

procedure BuildPrepare(Cnt:word; Prepare:PCallPrepares; var CStack:TDirectStack);assembler;
{ ନ ⥪    맮 ணࠬ אַ 맮 }
const SizeOfTCallPrepare=SizeOf(TCallPrepare);
asm
 push ds
 mov cx,Cnt
 les di,Prepare
 lds si,CStack
 or cx,cx
 je @1
@2:
 mov ax,es:[di].TCallPrepare.What
 mov dx,di { ࠭ di }
 mov bx,es:[di].TCallPrepare.ToOfs
 push es   { ࠭ es }
 les di,es:[di].TCallPrepare.From
 cmp ax,pctE2I
 je @lpctE2I
 cmp ax,pctE2W
 je @lpctE2W
 cmp ax,pctPE2I
 je @lpctPE2I
 cmp ax,pctE2L
 je @lpctE2L
 cmp ax,pctPE2L
 je @lpctPE2L
 cmp ax,pctE2E
 je @lpctE2E
 cmp ax,pctE2D
 je @lpctE2D
 cmp ax,pctPE2D
 je @lpctPE2D
 cmp ax,pctPP2P
 jne @lpctP2P

@lpctPP2P:      { PMatrix }
 { ᥩ es:di=^PMatrix }
 les di,es:[di]

@lpctP2P: { string, PMatrix, string  extended  뫪 }
 mov [si][bx],di   {  -  ⥪ }
 inc bx
 inc bx
 mov [si][bx],es

@lend:
 pop es
 mov di,dx
 add di,SizeOfTCallPrepare
 loop @2
 jmp @1

@lpctE2I: { byte,boolean,int  祭 }
 fld tbyte ptr es:[di]
 fistp word ptr [si][bx]
 jmp @lend
@lpctE2W: { word  祭 }
 fld tbyte ptr es:[di]
 fistp dword ptr CStack
 mov ax,word ptr CStack.word[0]
 mov [si][bx],ax
 jmp @lend

@lpctPE2I: { byte,boolean,int  뫪 }
 fld tbyte ptr es:[di]
 pop es    { ⠭ @Prepare }
 mov di,dx
 push es
 les di,es:[di].TCallPrepare.Aux {  ஬筮 ࠭ 楫 }
 fistp word ptr es:[di] { ⨬ 㤠 楫 }
 mov [si][bx],di        {  楫 -  ⥪ }
 inc bx
 inc bx
 mov [si][bx],es
 jmp @lend
@lpctE2L: { longint,pointer  祭 }
 fld tbyte ptr es:[di]
 fistp dword ptr [si][bx]
 jmp @lend
@lpctPE2L: { longint,pointer,word  뫪 }
 fld tbyte ptr es:[di]
 pop es    { ⠭ @Prepare }
 mov di,dx
 push es
 les di,es:[di].TCallPrepare.Aux {  ஬筮 ࠭ 楫 }
 fistp dword ptr es:[di] { ⨬ 㤠 楫 }
 mov [si][bx],di         {  楫 -  ⥪ }
 inc bx
 inc bx
 mov [si][bx],es
 jmp @lend
@lpctE2D: { double  祭 }
 fld tbyte ptr es:[di]
 fstp qword ptr [si][bx]
 jmp @lend
@lpctPE2D: { double  뫪 }
 fld tbyte ptr es:[di]
 pop es    { ⠭ @Prepare }
 mov di,dx
 push es
 les di,es:[di].TCallPrepare.Aux {  ஬筮 ࠭ double }
 fstp qword ptr es:[di] { ⨬ 㤠 double }
 mov [si][bx],di        {  double -  ⥪ }
 inc bx
 inc bx
 mov [si][bx],es
 jmp @lend
@lpctE2E: { extended  祭 }
 fld tbyte ptr es:[di]
 fstp tbyte ptr [si][bx]
 jmp @lend
@1:
 pop ds
end;

procedure MakeCall(DC:PDirectCall; FactPrep,SubrAdr:pointer);assembler;
{ 믮 맮 ணࠬ אַ 맮 }
const SizeOfTCallPrepare=SizeOf(TCallPrepare);
asm
 les di,DC
 mov cx,es:[di].TDirectCall.CallStackSize { ࠧ ⥪ }
 jcxz @2   { -  - }
 mov dx,ds { ࠭ ds }
 { ⠢ ds:si  砫 ⥪   }
 mov ax,es
 mov ds,ax
 mov si,di
 add si,offset TDirectCall.CallStack
 { ⠢ si  ᫥ ᫮ ⥪ }
 mov ax,cx
 dec ax
 shl ax,1
 add si,ax
 std
 { - - (⥪  ) -  ⥪ }
@1:
 lodsw
 push ax
 loop @1
 mov ds,dx { ⠭ ds }
@2:
 call dword ptr SubrAdr { 뢠 - }
 cld

 { ࠡ뢥 頥 祭 }
 les di,DC
 mov cx,es:[di].TDirectCall.AfterPrepare
 or cx,cx
 je @exit  { 祣  頥  ப }

 mov si,ax { ࠭ ax }
 { ⠢ es:di   ନ஢⥫, 뢠 ᫥ 맮 - }
 mov bx,es:[di].TDirectCall.PrepareSize
 mov al,SizeOfTCallPrepare
 mul bl
 les di,FactPrep
 add di,ax
 mov ax,si { ⠭ ax }

 push ds
@4:
 mov bx,es:[di].TCallPrepare.What {   }
 lds si,es:[di].TCallPrepare.From { 㤠  }
 push di  { ࠭ es,di }
 push es
 cmp bx,pctI2E
 je @lpctI2E
 cmp bx,pctL2E
 je @lpctL2E
 cmp bx,pctD2E
 je @lpctD2E

 { ࠡ뢠 祭,頥 - १ ॣ }
 and bx,not 100h
 cmp bx,prtBoolean
 ja @6
 { १ al - boolean,char  byte }
 xor ah,ah
 mov FactPrep.word[0],ax
 fild word ptr FactPrep
 jmp @8
@6:
 cmp bx,prtInt
 ja @7
 { १ ax - int }
 mov FactPrep.word[0],ax
 fild word ptr FactPrep
 jmp @8
@7:
 cmp bx,prtWord
 ja @10
 { १ ax - word }
 xor dx,dx
 jmp @11
@10:
 cmp bx,prtPointer
 ja @8
 { १ dx:ax - longint  pointer }
@11:
 mov FactPrep.word[0],ax { FactPrep    㦭 }
 mov FactPrep.word[2],dx
 fild dword ptr FactPrep
@8:
 { १ ⥪ 87 - double  extended }
 fstp tbyte ptr [si]

@5:
 pop es { ⠭ }
 pop di
 add di,SizeOfTCallPrepare {  ᫥  ⥫ }
 loop @4
 jmp @9

@lpctI2E: { 뫠 । int  뫪 }
 les di,es:[di].TCallPrepare.Aux
 fild word ptr es:[di]
 fstp tbyte ptr [si]
 jmp @5
@lpctL2E: { 뫠 । longint,word  뫪 }
 les di,es:[di].TCallPrepare.Aux
 fild dword ptr es:[di]
 fstp tbyte ptr [si]
 jmp @5
@lpctD2E: { 뫠 । double  뫪 }
 les di,es:[di].TCallPrepare.Aux
 fld qword ptr es:[di]
 fstp tbyte ptr [si]
 jmp @5
@9:
 pop ds
@exit:
end;

procedure fCalcDirectSubr(Var P:TCalcCell);
begin
 with P do
  with PDirectCall(T1)^ do begin
   BuildPrepare(PrepareSize,T2,CallStack);
   MakeCall(PDirectCall(T1),{@PCallPrepares(}T2{)^[PrepareSize]},FuncAdr);
  end
end;

Procedure fStrConcat(Var P:TCalcCell);
Var L:PText;
Begin
 With P do begin
  PText(ResultP)^:=PText(Ppointer(T1)^)^+PText(Ppointer(T2)^)^;
  L:=PText(ResultP)
 end
End;

Procedure fCalcArray(Var P:TCalcCell);
Var L:word;
Begin
 With P do begin
  L:=Round(PFloat(T1)^);
  Result:=PFloat(PMatrixF(PStructDef(T2)^.Data)^.Get(L))^
 end
End;

Procedure fCalcStrArray(Var P:TCalcCell);
Var L:word;
Begin
 With P do begin
  L:=Round(PFloat(T1)^);
  ResultP:=PStrMatrix(PStructDef(T2)^.Data)^.Get(L);
 end
End;

Procedure fCalcMatrix(Var P:TCalcCell);
Var L1,L2:word;
Begin
 With P do begin
  L1:=Round(PFloat(T1)^);
  L2:=Round(PFloat(Aux)^);
  Result:=PFloat(PMatrixF(PStructDef(T2)^.Data)^.Get2(L1,L2))^
 end
End;

Procedure fCalcUserParFunc(Var P:TCalcCell);
Begin
 With P do begin
  PCalcer(PFunction(T1)^.FuncCalc)^.Evaluate;
  Result:=PFunction(T1)^.FuncName^.Value
 end
End;

Procedure fCalcUserParProc(Var P:TCalcCell);
Begin
 With P do PCalcer(PFunction(T1)^.FuncCalc)^.Evaluate;
End;

Procedure fMailPar(Var P:TCalcCell);
Begin
 With P do PHashCell(PPointer(T1)^)^.Value:=PFloat(T2)^
End;

Procedure fMailStruct(Var P:TCalcCell);
Begin
 With P do
  PStructDef(PHashCell(PPointer(T1)^)^.WhatD)^.Data:=PPointer(T2)^
End;

Procedure fMailPFunction(Var P:TCalcCell);
Begin
 With P do
 FastMoveWord(PFunction(T2)^,PFunction(T1)^, SizeOf(TFunction) div 2)
End;

Procedure fPlus(Var P:TCalcCell);
Begin
 With P do Result:=PFloat(T1)^+PFloat(T2)^;
End;

Procedure fMinus(Var P:TCalcCell);
Begin
 With P do Result:=PFloat(T1)^-PFloat(T2)^;
End;

Procedure fDiv(Var P:TCalcCell);
Begin
 With P do Result:=PFloat(T1)^/PFloat(T2)^;
End;

Procedure fPower(Var P:TCalcCell);
Begin
 With P do Result:=Exp(PFloat(T1)^*Ln(PFloat(T2)^));
End;

Procedure fMult(Var P:TCalcCell);
Begin
 With P do Result:=PFloat(T1)^*PFloat(T2)^;
End;

Procedure fLOG(Var P:TCalcCell);
Begin
 With P do Result:=Ln(PFloat(T1)^)/Ln(10);
End;

Procedure fAbs(Var P:TCalcCell);
Begin
 With P do Result:=Abs(PFloat(T1)^)
End;

Procedure fSign(Var P:TCalcCell);
Begin
 With P do
  If PFloat(T1)^<0 then Result:=-1
  else
   If PFloat(T1)^>0 then Result:=1 else Result:=0
End;

Procedure fAsin(Var P:TCalcCell);
Begin
 With P do
  If PFloat(T1)^=1 then Result:=Pi/2
  else Result:=Arctan(PFloat(T1)^/Sqrt(1-Sqr(PFloat(T1)^)));
End;

Procedure fAcos(Var P:TCalcCell);
Begin
 With P do
  If PFloat(T1)^=0 then Result:=Pi/2
  else Result:=Arctan(Sqrt(1-Sqr(PFloat(T1)^))/PFloat(T1)^);
End;

const a180:word=180;

Procedure fRad(Var P:TCalcCell);assembler;
{ With P do Result:=Pi/180*PFloat(T1)^ }
asm
 fldpi       { pi }
 fild a180   { 180 }
 fdiv        { pi/180 }
 les di,P
 les di,es:[di].TCalcCell.T1
 fld tbyte ptr es:[di]
 fmul        { pi/180*Angle }
 fwait
 les di,P
 fstp tbyte ptr es:[di].TCalcCell.Result
 fwait
end;

Procedure fGrad(Var P:TCalcCell);assembler;
{ With P do Result:=180/Pi*PFloat(T1)^ }
asm
 fild a180   { 180 }
 fldpi       { pi }
 fdiv        { 180/pi }
 les di,P
 les di,es:[di].TCalcCell.T1
 fld tbyte ptr es:[di]
 fmul        { 180/pi*Angle }
 les di,P
 fstp tbyte ptr es:[di].TCalcCell.Result
 fwait
end;

Procedure fCos(Var P:TCalcCell);
Begin
 With P do Result:=Cos(PFloat(T1)^)
End;

Procedure fSin(Var P:TCalcCell);
Begin
 With P do Result:=Sin(PFloat(T1)^)
End;

Procedure fTg(Var P:TCalcCell);
Begin
 With P do Result:=Sin(PFloat(T1)^)/Cos(PFloat(T1)^)
End;

Procedure fArcTg(Var P:TCalcCell);
Begin
 With P do Result:=ArcTan(PFloat(T1)^)
End;

Procedure fSqrt(Var P:TCalcCell);
Begin
 With P do Result:=Sqrt(PFloat(T1)^)
End;

Procedure fSqr(Var P:TCalcCell);
Begin
 With P do Result:=Sqr(PFloat(T1)^)
End;

Procedure fExp(Var P:TCalcCell);
Begin
 With P do Result:=Exp(PFloat(T1)^)
End;

Procedure fLn(Var P:TCalcCell);
Begin
 With P do Result:=Ln(PFloat(T1)^)
End;

Procedure fNeg(Var P:TCalcCell);
Begin
 With P do Result:=-PFloat(T1)^
End;

Procedure fFrac(Var P:TCalcCell);
Begin
 With P do Result:=Frac(PFloat(T1)^)
End;

Procedure fRound(Var P:TCalcCell);
Var L:longint;
Begin
 With P do begin
  L:=Round(PFloat(T1)^);
  Result:=L
 end
End;

Procedure fTrunc(Var P:TCalcCell);
Begin
 With P do Result:=Trunc(PFloat(T1)^)
End;

Procedure fLDiv(Var P:TCalcCell);
Var L1,L2:longint;
Begin
 With P do begin
  L1:=Round(PFloat(T1)^);
  L2:=Round(PFloat(T2)^);
  L1:=L1 div L2;
  Result:=L1
 end
End;

Procedure fLMod(Var P:TCalcCell);
Var L1,L2:longint;
Begin
 With P do begin
  L1:=Round(PFloat(T1)^);
  L2:=Round(PFloat(T2)^);
  L1:=L1 mod L2;
  Result:=L1
 end
End;

Procedure fError(Var P:TCalcCell);
Begin
 With P do Result:=longint(NotNumber(PFloat(T1)^))
End;


Procedure fBG(Var P:TCalcCell);
Begin
 With P do Resultb:=PCalcer(T1)^.Calculate^>PCalcer(T2)^.Calculate^
End;

Procedure fBGE(Var P:TCalcCell);
Begin
 With P do Resultb:=PCalcer(T1)^.Calculate^>=PCalcer(T2)^.Calculate^
End;

Procedure fBL(Var P:TCalcCell);
Var X1,X2:extended;
Begin
 With P do begin
  X1:=PCalcer(T1)^.Calculate^;
  X2:=PCalcer(T2)^.Calculate^;
  {writeln(X1,' ',X2);}
  Resultb:=X1<X2
 end
End;

Procedure fBLE(Var P:TCalcCell);
Begin
 With P do Resultb:=PCalcer(T1)^.Calculate^<=PCalcer(T2)^.Calculate^
End;

Procedure fBE(Var P:TCalcCell);
Begin
 With P do Resultb:=PCalcer(T1)^.Calculate^=PCalcer(T2)^.Calculate^
End;

Procedure fBNE(Var P:TCalcCell);
Begin
 With P do Resultb:=PCalcer(T1)^.Calculate^<>PCalcer(T2)^.Calculate^
End;

const
 fzero:longint=0;
 fone:double=1;

procedure fIsZero(Var P:TCalcCell);
{ True ᫨ T1^=0 }
var K:pointer;
begin
{ Tmp:=PCalcer(P.T1)^.Calculate^;
  P.ResultB:=Tmp=0 }
 K:=PCalcer(P.T1)^.Calculate;
 asm
  les di,K
  xor bx,bx
  fld tbyte ptr es:[di]
  fcomp fzero
  fstsw ax
  fwait
  test ax,4000h
  jz @1
  inc bx
 @1:
  les di,P
  mov byte ptr es:[di].TCalcCell.ResultB,bl
 end;
end;

procedure fIsOne(Var P:TCalcCell);
{ True ᫨ T1^=1 }
var K:pointer;
begin
 K:=PCalcer(P.T1)^.Calculate;
 asm
  xor bx,bx
  les di,K
  fld tbyte ptr es:[di]
  fcomp fone
  fstsw ax
  fwait
  test ax,4000h
  jz @1
  inc bx
 @1:
  les di,P
  mov byte ptr es:[di].TCalcCell.ResultB,bl
 end
end;

Procedure fsBG(Var P:TCalcCell);
Begin
 With P do Resultb:=
  PText(Ppointer(PCalcer(T1)^.Calculate)^)^>
  PText(Ppointer(PCalcer(T2)^.Calculate)^)^
End;

Procedure fsBGE(Var P:TCalcCell);
Begin
 With P do Resultb:=
  PText(Ppointer(PCalcer(T1)^.Calculate)^)^>=
  PText(Ppointer(PCalcer(T2)^.Calculate)^)^
End;

Procedure fsBL(Var P:TCalcCell);
Begin
 With P do Resultb:=
  PText(Ppointer(PCalcer(T1)^.Calculate)^)^<
  PText(Ppointer(PCalcer(T2)^.Calculate)^)^
End;

Procedure fsBLE(Var P:TCalcCell);
Begin
 With P do Resultb:=
  PText(Ppointer(PCalcer(T1)^.Calculate)^)^<=
  PText(Ppointer(PCalcer(T2)^.Calculate)^)^
End;

Procedure fsBE(Var P:TCalcCell);
Begin
 With P do Resultb:=
  PText(Ppointer(PCalcer(T1)^.Calculate)^)^=
  PText(Ppointer(PCalcer(T2)^.Calculate)^)^
End;

Procedure fsBNE(Var P:TCalcCell);
Begin
 With P do Resultb:=
  PText(Ppointer(PCalcer(T1)^.Calculate)^)^<>
  PText(Ppointer(PCalcer(T2)^.Calculate)^)^
End;

Type PBoolean=^boolean;

Procedure fLAnd(Var P:TCalcCell);
Begin
 With P do Resultb:=PBoolean(T1)^ and PBoolean(T2)^
End;

Procedure fLOr(Var P:TCalcCell);
Begin
 With P do Resultb:=PBoolean(T1)^ or PBoolean(T2)^
End;

Procedure fLNot(Var P:TCalcCell);
Begin
 With P do Resultb:=not PBoolean(T1)^
End;

Procedure fLXor(Var P:TCalcCell);
Begin
 With P do Resultb:=PBoolean(T1)^ xor PBoolean(T2)^
End;
