{ (c) Copyright 1995,1996 㭨 .. bunin@mes.djug.pyatigorsk.su }
Unit UserFunc; { প - - }
{$B-}{$F+}{$A+}{$N+}{$R-}{$S-}{$V-}{$I-}{$G+}{$B-}{$X+}{$T-}

Interface
Uses Hash2x2,Def2x2,Calcer;

Type
 HashArray=array[1..MaxFuncPars] of THashCell;
 PHashArray=^HashArray;

 PMultiFact=^TMultiFact;
 TMultiFact=record
  What:TMultiExprType;
  ByValue:boolean;
  Value:pointer
 end;

 { ࠪ - - - }
 TFuncObject=object(TCalcer)
  F:TFunction;
  H:PHashCell;     {  -; ⥭ ᫥ ॣ樨 }
  Name:TermString; {  - }
  constructor Init;
  { ॣ -  ; 頥 False, ᫨ ⠪  㦥  }
  function Register(Hash:PTermhash):boolean;virtual;
 end;

 { - 楤 - }
 PUserProc=^TUserProc;
 TUserProc=object(TFuncObject)
  { , ᫮ -, ᫮ -,।  뫪 }
  constructor Init(AName:TermString; ArgCount,AParVars:byte);

  procedure ClearMultiList(ParNum:integer);
  {  ᠭ - ⨯ Float, IsVar=True, ᫨ । 
    뫪. 頥  - }
  function InsertFloatPar(IsVar:boolean):PFloat;

  {  ᠭ - ⨯ String, IsVar=True, ᫨ । 
    뫪. 頥  ப }
  function InsertStrPar(IsVar:boolean):PText;

  {  ᠭ - ⨯ Array, 頥 ,  ஬
    㤥 । - PMatrix }
  function InsertArrayPar:Ppointer;
  function InsertStrArrayPar:Ppointer;
  function InsertAnyArrayPar:Ppointer;

  procedure InsertMultiPar;

  {  ᠭ - ⨯ 짮⥫, TypeId - 䨪 ⨯
    짮⥫, IsVar=True, ᫨ ।  뫪. 頥  - }
  function InsertUserTypePar(TypeId:TUserVarType; IsVar:boolean):PFloat;

  {  ᠭ - ⨯ Polinom, 頥 ,  ஬
    㤥 । - PPolinom }
  function InsertPolinomPar:Ppointer;

  {  ᠭ - ⨯ Func, ParTypes-ப,
    뢠 ⨯ - (  ᨬ -  - ):
    '*' - Float
    '@' - Float  뫪
    'A' - Array
    'O' - Polinom }
  procedure InsertFuncPar(ParTypes:string);
  procedure InsertProcPar(ParTypes:string);

  { - । -  맮 ---;
    Par - 浪  -  ᯨ᪥ -, Data - ᨢ 㪠-
     । -:
      Float        : 㪠- ⨯ PFloat;
      Array,Polinom: 㪠- ⨯ PMatrix }
  function CallParFunc(Par:byte; Var Data):Float;

  function NumOfMultiArgs(ParNum:integer):integer;
  procedure MultiArgDesc(ParNum,ArgNum:integer; var ArgType:TMultiExprType; var AByValue:boolean);
  function MultiArgValue(ParNum,ArgNum:integer):pointer;

  function Register(Hash:PTermhash):boolean;virtual;
  destructor Done;virtual;
 private
  Hashes:PHashArray; {  - }
  CurCell:byte;      { ⥪.  - }
 end;

 { - 㭪樨 - }
 PUserFunc=^TUserFunc;
 TUserFunc=object(TUserProc)
   constructor Init(AName:TermString; ArgCount,AParVars:byte; Options:TFuncOptions);
  {  易⥫쭮 -  ⮤ Evaluate. । ᫥
    - Res^ -  맢襥  ࠦ- }
  procedure SetResult(Res:PFloat);
  procedure AssignResult(Res:pointer);virtual;
  function Register(Hash:PTermhash):boolean;virtual;
  procedure AssignValue(Value:pointer);virtual;
 end;

 { - ப - - }
 PUserStrFunc=^TUserStrFunc;
 TUserStrFunc=object(TUserFunc)
  {  易⥫쭮 -  ⮤ Evaluate. । १-
    Res^ -  맢襥  ࠦ- }
  procedure SetResult(Res:PText);
  function Register(Hash:PTermhash):boolean;virtual;
  destructor Done;virtual;
 end;

Implementation
Uses MyString,X1,Objects;

Constructor TFuncObject.Init;
Begin
 Inherited Init;
 With F do begin
  FuncCalc:=@Self; NParVars:=0; EnableAssign:=0;
  SimpleIfAllConst:=False;
 end
End;

Function TFuncObject.Register(Hash:PTermHash):boolean;
Begin
 Register:=False;
 GetHashKey(Name); { - - }
 If Hash^.Search(Name,True,AllMask,H) then exit; { ⠪  㦥  }
 F.FuncName:=H;
 H^.WhatD:=@F;
 Register:=True
End;

Constructor TUserProc.Init(AName:TermString; ArgCount,AParVars:byte);
Var I:byte;
Begin
 TCalcer.Init;
 With F do begin
  FuncCalc:=@Self; NParVars:=AParVars; NPars:=ArgCount;
  EnableAssign:=0;
 end;
 Name:=UpperCase(AName);
 GetMem(Hashes,SizeOf(THashCell)*ArgCount);
 CurCell:=0;
 For I:=1 to ArgCount do F.Pars[I].Hash:=@Hashes^[I]
End;

procedure TUserProc.ClearMultiList(ParNum:integer);
var i:integer;
begin
 with Hashes^[ParNum] do
  with PCollection(WhatD)^ do begin
   For i:=1 to Count do Dispose(PMultiFact(At(Pred(i))));
   DeleteAll
  end
end;

Function TUserProc.InsertFloatPar(IsVar:boolean):PFloat;
Var I:word;
Begin
 Inc(CurCell);
 If IsVar then begin
  I:=opPar;
  F.SimpleIfAllConst:=False
 end
 else I:=opVar;
 F.Pars[CurCell].TermType:=I;
 InsertFloatPar:=@Hashes^[CurCell].Value
End;

Function TUserProc.InsertStrPar(IsVar:boolean):PText;
Var I:word; P:PText;
Begin
 Inc(CurCell);
 If IsVar then begin
  I:=opStringPar;
  F.SimpleIfAllConst:=False
 end
 else I:=opStringVar;
 F.Pars[CurCell].TermType:=I;
 New(P);
 Hashes^[CurCell].ValueP:=P;
 InsertStrPar:=P
End;

Function TUserProc.InsertArrayPar:Ppointer;
Var P:PStructDef;
Begin
 Inc(CurCell);
 F.Pars[CurCell].TermType:=opArrayVar;
 F.SimpleIfAllConst:=False;
 New(P);
 Hashes^[CurCell].WhatD:=P;
 InsertArrayPar:=@P^.Data; { ^PMatrix }
End;

function TUserProc.InsertUserTypePar(TypeId:TUserVarType; IsVar:boolean):PFloat;
var i:integer;
Begin
 Inc(CurCell);
 If IsVar then begin
  I:=utfByPar;
  F.SimpleIfAllConst:=False
 end
 else I:=0;
 F.Pars[CurCell].UTFlag:=I;
 F.Pars[CurCell].TermType:=TypeId+UserTypeVarDelta;
 InsertUserTypePar:=@Hashes^[CurCell].Value
End;

Procedure TUserProc.InsertMultiPar;
Var P:PStructDef;
Begin
 Inc(CurCell);
 F.Pars[CurCell].TermType:=opMultiVar;
 Hashes^[CurCell].WhatD:=New(PCollection,Init(10,10));
End;

Function TUserProc.NumOfMultiArgs(ParNum:integer):integer;
begin
 If F.Pars[ParNum].TermType=opMultiVar then
  NumOfMultiArgs:=PCollection(Hashes^[ParNum].WhatD)^.Count
 else NumOfMultiArgs:=0
end;

Procedure TUserProc.MultiArgDesc(ParNum,ArgNum:integer; var ArgType:TMultiExprType;
 var AByValue:boolean);
begin
 With F.Pars[ParNum] do
  If (TermType=opMultiVar) and (ArgNum<=NumOfMultiArgs(ParNum)) then
   with PMultiFact(PCollection(Hashes^[ParNum].WhatD)^.At(ArgNum-1))^ do begin
    ArgType:=What;
    AByValue:=ByValue
   end
end;

Function TUserProc.MultiArgValue(ParNum,ArgNum:integer):pointer;
begin
 With F.Pars[ParNum] do
  If (TermType=opMultiVar) and (ArgNum<=NumOfMultiArgs(ParNum)) then
   with PMultiFact(PCollection(Hashes^[ParNum].WhatD)^.At(ArgNum-1))^ do
    MultiArgValue:=Value
  else MultiArgValue:=nil
end;

Function TUserProc.InsertStrArrayPar:Ppointer;
Var P:PStructDef;
Begin
 InsertStrArrayPar:=InsertArrayPar;
 F.Pars[CurCell].TermType:=opStrArrVar;
End;

Function TUserProc.InsertAnyArrayPar:Ppointer;
Var P:PStructDef;
Begin
 InsertAnyArrayPar:=InsertArrayPar;
 F.Pars[CurCell].TermType:=opAnyArrVar;
End;

Function TUserProc.InsertPolinomPar:Ppointer;
Begin
 InsertPolinomPar:=InsertArrayPar;
 F.Pars[CurCell].TermType:=opPolinom;
End;

Procedure TUserProc.InsertFuncPar(ParTypes:string);
Var I:word; Len:byte absolute ParTypes; ParFunc:PFunction;
Begin
 Inc(CurCell);
 F.Pars[CurCell].TermType:=opUserFunc;
 F.SimpleIfAllConst:=False;
 New(ParFunc);
 ParFunc^.NPars:=Len;
 Hashes^[CurCell].WhatD:=ParFunc;

 {  맮 襩 -, --- ParFunc^ 㤥  
   ᮤন TFunction 䠪. -.  ⮬  
   - -   -  ᪮쪨  }

 {  맮 襩 -   Pars  ᠭ Pars 䠪.
   -,  Pars[I].TermType ⥬   㦭 -, .. 
   ࠭樨 ஢- ᮮ⢥⢨ ⨯ - }

 For I:=1 to Len do
  With ParFunc^.Pars[I] do
   Case UpperChar(ParTypes[I]) of
    '*': TermType:=opVar;
    '@': TermType:=opPar;
    'A': TermType:=opArrayVar;
    'O': TermType:=opPolinom;
   end;
End;

Procedure TUserProc.InsertProcPar(ParTypes:string);
Begin
 InsertFuncPar(ParTypes);
 F.Pars[CurCell].TermType:=opUserProc;
End;

Function TUserProc.CallParFunc(Par:byte; Var Data):Float;
Type PArr=array[1..MaxFuncPars] of pointer;
Var I:word; ParFunc:PFunction;
Begin
 ParFunc:=Hashes^[Par].WhatD;
 { । - - । 맮 --- }

 { । 맮 襩 -  ParFunc^.Pars[..] 㦥 饭 
   - 䠪. --- }
 For I:=1 to ParFunc^.NPars do
  With ParFunc^.Pars[I] do
   Case TermType of
    {   䠪. - । - Float }
    opPar,opVar: Hash^.Value:=PFloat(PArr(Data)[I])^;
    {  TStructDef 䠪. - । PMatrix }
    opArrayVar,opPolinom: PStructDef(Hash^.WhatD)^.Data:=PArr(Data)[I];
   end;

 { 뢠 - }
 PCalcer(ParFunc^.FuncCalc)^.Evaluate;

 {  --뫮 頥 - }
 For I:=1 to ParFunc^.NPars do
  With ParFunc^.Pars[I] do
   If TermType=opPar then PFloat(PArr(Data)[I])^:=Hash^.Value;

 { 頥 १- }
 CallParFunc:=ParFunc^.FuncName^.Value
End;

Constructor TUserFunc.Init(AName:TermString; ArgCount,AParVars:byte;
 Options:TFuncOptions);
Begin
 Inherited Init(AName,ArgCount,AParVars);
 If foAsProperty in Options then F.EnableAssign:=1;
 If (foSimplified in Options) and (AParVars=0) then F.SimpleIfAllConst:=True
End;

Procedure TUserFunc.SetResult(Res:PFloat);
Begin
 H^.Value:=Res^ { १- - -     }
End;

Procedure TUserFunc.AssignValue(Value:pointer);
Begin End;

Procedure TUserFunc.AssignResult(Res:pointer);
Begin End;

Destructor TUserProc.Done;
Var I:word;
Begin
 For I:=1 to F.NPars do With F do
  Case Pars[I].TermType of
   opStringVar,opStringPar: Dispose(PText(Hashes^[I].ValueP));
   opArrayVar..opStrArrVar,opAnyArrVar: Dispose(PStructDef(Hashes^[I].WhatD));
   opUserFunc: Dispose(PFunction(Hashes^[I].WhatD));
   opMultiVar:begin
    ClearMultiList(I);
    Dispose(PCollection(Hashes^[I].WhatD),Done);
   end
  end;
 FreeMem(Hashes,SizeOf(THashCell)*F.NPars);
 Inherited Done
End;

Function TUserProc.Register(Hash:PTermhash):boolean;
Begin
 Inherited Register(Hash);
 H^.TermType:=opUserProc
End;

Function TUserFunc.Register(Hash:PTermhash):boolean;
Begin
 Inherited Register(Hash);
 H^.TermType:=opUserFunc
End;

Procedure TUserStrFunc.SetResult(Res:PText);
Begin
 H^.ValueP^:=Res^ { १- - -     }
End;

Function TUserStrFunc.Register(Hash:PTermhash):boolean;
Begin
 TFuncObject.Register(Hash);
 New(H^.ValueP); { 뤥塞   १- }
 H^.TermType:=opStringFunc
End;

Destructor TUserStrFunc.Done;
Begin
 Dispose(H^.ValueP);
 Inherited Done
End;

End.
